open (INFILE,"stateDefs.xml"); #genearted by Statecondsgenerator.pl
@dp=<INFILE>;
$precision = 0;
foreach $line(@dp)
{
    if($line =~ /<double precision>(.+)<\/double precision>/)
    {
	$precision = $1;
	$precision =~ s/\s//g;
	last;
    }
}
close INFILE;
open (INFILE,"stateConds.txt"); #genearted by Statecondsgenerator.pl
open (OUTFILE,">determineCurrentState.java");
@vars=<INFILE>;
#$temp=join("",@vars);
#$temp =~ //;
#print OUTFILE "class chkStSpace{\n";

@vars[0] =~ s/\//\_/g;
@vars[0] =~ s/,/\;\n/g;

#print $vars[0];
@var = split(/\n/,$vars[0]);

@dvarlist = ();  # required for comparison of double variables
foreach $item(@var)
{
    if($item =~ /^\s*double\s+(.+);/)
    {
	push(@dvarlist, $1);
    }
}

#print OUTFILE @vars[0];
print OUTFILE "static String determineCurrentState(String varName){\n";
$count=0;
$varName = "";
foreach $line(@vars)
{
if ($result=$line =~ /#/)
{
$line =~ s/\#//g;
$line =~ s/\n//g;
if ($count>0)
{
#print OUTFILE "}\n";
}
#print OUTFILE "if(varName.compareTo(\"$line\")==0){\n";
$count=$count+1;
$varName = $line;
}
if($result=$line =~ /~/)
{
($cond,$state)=split(/~/,$line);
$cond =~ s/\n//g;
$state =~ s/\n//g;
print OUTFILE "if (varName.compareTo(\"$varName\")==0";

$cnd = $cond;  # required to remove NullPointerException for String state variables
while($cnd =~ /\.\D/)
{
    $cnd = " " . $cnd;
    $cnd =~ s/[\s\(](\S+?)\.//;  # String variable is preceeded by a \s or (
    #print $1 . " ";
    print OUTFILE " && $1!=null";
}

print OUTFILE ") {\n";

$cnd = $cond; # required for comparison of double variables
while($cnd =~ /[!=]=/)
{
    $cnd = " " . $cnd;
    $cnd =~ s/\s+(\S+?)\s*([!=]=)\s*(-*\d*\.*\d*)//;
    foreach $dvar(@dvarlist)  # compare if $1 is in @dvarlist
    {
	if($dvar eq $1)
	    {
		$dvarname = $1;
		$sign = $2;
		$value = $3;
		if($sign eq "==")
		{
		    $cond =~ s/$dvarname\s*$sign\s*$value/java\.lang\.Math\.abs\($dvarname-\($value\)\) < $precision/;
		}
		elsif($sign eq "!=")
		{
		    $cond =~ s/$dvarname\s*$sign\s*$value/java\.lang\.Math\.abs\($dvarname-\($value\)\) > $precision/;
		}
	    }
    }
}

print OUTFILE "	if ($cond)
	{
	return (\"$state\");
	}\n}\n";
}
}
#print OUTFILE "}\n";
print OUTFILE "\nreturn(lastState);\n}\n\n";